package com.vendor.loader.ui.ssu;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.loader.Messages;
import com.vendor.loader.util.ssu.SsuPackageOptions;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Text;

public class SsuPackageOptionsInfoGroup {
  private Button insertLinkedDescriptorBtn;
  
  private Button insertEmptyPacketBtn;
  
  private Label transferModeLabel;
  
  private Combo transferModeCombo;
  
  private Label upgradetypeLabel;
  
  private Combo upgradetypeCombo;
  
  private Label symbolRateLabel;
  
  private Text symbolRateText;
  
  private Label validSymbolRateLabel;
  
  private Text validSymbolRateText;
  
  private Label mbpsLabel;
  
  private Label mbpsLabel1;
  
  private Label centreFrequencyLabel;
  
  private Text centreFrequencyText;
  
  private Label centerFrequencyValid;
  
  private Label bandwidthLabel;
  
  private Combo bandwidthCombo;
  
  private Label constellationLabel;
  
  private Combo constellationCombo;
  
  private Label cableModulationLabel;
  
  private Combo cableModulationCombo;
  
  private Label cableFrequencyLabel;
  
  private Text cableFrequencyText;
  
  private Label cableFrequencyGHz;
  
  private SsuPackageOptions input;
  
  public SsuPackageOptionsInfoGroup(Composite parent) {
    createControls(parent);
  }
  
  private void setSelectButton(Button btn, Composite group) {
    btn.addSelectionListener((SelectionListener)new Object(this, btn));
  }
  
  private void setSelectText(Text text, int number) {
    text.addSelectionListener((SelectionListener)new Object(this));
  }
  
  private void createControls(Composite group) {
    group.setLayout((Layout)new GridLayout(1, false));
    Composite com = new Composite(group, 0);
    com.setLayout((Layout)new GridLayout(3, false));
    GridData gridData = new GridData(4, 1, true, false);
    com.setLayoutData(gridData);
    fillGridFill((Control)group);
    GridLayout gridLayout = null;
    this.insertLinkedDescriptorBtn = new Button(com, 32);
    this.insertLinkedDescriptorBtn.setText(Messages.InsertLinkedDescriptor);
    this.insertLinkedDescriptorBtn.setData("number", Integer.valueOf(0));
    setSelectButton(this.insertLinkedDescriptorBtn, group);
    this.insertEmptyPacketBtn = new Button(com, 32);
    this.insertEmptyPacketBtn.setText(Messages.InsertEmptyPacket);
    this.insertEmptyPacketBtn.setData("number", Integer.valueOf(1));
    setSelectButton(this.insertEmptyPacketBtn, group);
    Composite comLayout = new Composite(group, 0);
    gridLayout = new GridLayout(7, false);
    gridLayout.horizontalSpacing = 12;
    gridLayout.marginTop = 0;
    gridLayout.marginHeight = 0;
    gridLayout.marginWidth = 0;
    comLayout.setLayout((Layout)gridLayout);
    this.upgradetypeLabel = new Label(comLayout, 0);
    this.upgradetypeLabel.setText(Messages.UpgradeType + ":");
    fillHorizontal((Control)this.upgradetypeLabel);
    this.upgradetypeCombo = new Combo(comLayout, 8);
    this.upgradetypeCombo.setItems(new String[] { Messages.Undefined, Messages.Forcibleupgrade, Messages.Nonforcibleupgrade });
    this.upgradetypeCombo.select(1);
    fillHorizontal((Control)this.upgradetypeCombo);
    this.transferModeLabel = new Label(comLayout, 0);
    this.transferModeLabel.setText(Messages.TransferMode + ":");
    fillHorizontal((Control)this.transferModeLabel);
    this.transferModeCombo = new Combo(comLayout, 8);
    this.transferModeCombo.setItems(new String[] { Messages.Cable, Messages.Terrestrial });
    this.transferModeCombo.select(0);
    fillHorizontal((Control)this.transferModeCombo);
    this.transferModeCombo.addSelectionListener((SelectionListener)new Object(this));
    int integerBits = 3;
    int fractionalBits = 4;
    this.symbolRateLabel = new Label(comLayout, 16384);
    this.symbolRateLabel.setText(Messages.SymbolRate + ":");
    fillHorizontal((Control)this.symbolRateLabel, 310);
    this.symbolRateText = new Text(comLayout, 16779268);
    this.symbolRateText.setText("6875");
    this.symbolRateText.setTextLimit(5);
    setVerifyIntText(this.symbolRateText, Messages.SymbolRate, 1000, 99999L, integerBits, fractionalBits);
    fillHorizontal((Control)this.symbolRateText, 50);
    setSelectText(this.symbolRateText, 0);
    this.mbpsLabel = new Label(comLayout, 16777216);
    this.mbpsLabel.setText("KS/s");
    fillHorizontal((Control)this.mbpsLabel, 50);
    this.validSymbolRateLabel = new Label(comLayout, 16384);
    this.validSymbolRateLabel.setText(Messages.ValidSymbolRate + ":");
    fillHorizontal((Control)this.validSymbolRateLabel, 260);
    this.validSymbolRateText = new Text(comLayout, 16779268);
    this.validSymbolRateText.setText("1000");
    this.validSymbolRateText.setTextLimit(5);
    fillHorizontal((Control)this.validSymbolRateText, 50);
    setVerifyIntText(this.validSymbolRateText, Messages.ValidSymbolRate, 1000, 99999L, integerBits, fractionalBits);
    setSelectText(this.validSymbolRateText, 1);
    this.mbpsLabel1 = new Label(comLayout, 16777216);
    this.mbpsLabel1.setText("KS/s");
    fillHorizontal((Control)this.mbpsLabel1, 50);
    createCableControls(group);
    createTerrestrialControls(group);
    setEnabledAll(false);
  }
  
  private void createCableControls(Composite group) {
    Composite comLayout = new Composite(group, 0);
    fillGridFill((Control)group);
    GridLayout gridLayout = new GridLayout(10, false);
    gridLayout.horizontalSpacing = 12;
    gridLayout.marginTop = 0;
    gridLayout.marginHeight = 0;
    gridLayout.marginWidth = 0;
    comLayout.setLayout((Layout)gridLayout);
    this.cableModulationLabel = new Label(comLayout, 0);
    this.cableModulationLabel.setText(Messages.CableModulation + ":");
    fillHorizontal((Control)this.cableModulationLabel);
    this.cableModulationCombo = new Combo(comLayout, 8);
    this.cableModulationCombo.setItems(new String[] { Messages.CableModulation00, Messages.CableModulation01, Messages.CableModulation02, Messages.CableModulation03, Messages.CableModulation04, Messages.CableModulation05 });
    this.cableModulationCombo.select(3);
    fillHorizontal((Control)this.cableModulationCombo);
    this.cableFrequencyLabel = new Label(comLayout, 0);
    this.cableFrequencyLabel.setText(Messages.CableFrequency + ":");
    fillHorizontal((Control)this.cableFrequencyLabel);
    this.cableFrequencyText = new Text(comLayout, 16779268);
    this.cableFrequencyText.setText("618");
    int min = 1;
    long max = 9999L;
    int integerBits = 4;
    int fractionalBits = 4;
    setVerifyIntText(this.cableFrequencyText, "Frequency", min, max, integerBits, fractionalBits);
    this.cableFrequencyText.setTextLimit(9);
    fillHorizontal((Control)this.cableFrequencyText);
    this.cableFrequencyGHz = new Label(comLayout, 0);
    this.cableFrequencyGHz.setText("MHz");
    fillHorizontal((Control)this.cableFrequencyGHz);
  }
  
  public static GridData fillHorizontal(Control control, int widthHint) {
    GridData layoutData = new GridData(768);
    layoutData.widthHint = widthHint;
    control.setLayoutData(layoutData);
    return layoutData;
  }
  
  public static GridData fillHorizontal(Control control) {
    GridData layoutData = new GridData(768);
    layoutData.widthHint = 160;
    control.setLayoutData(layoutData);
    return layoutData;
  }
  
  private void createTerrestrialControls(Composite group) {
    Composite comLayout = new Composite(group, 0);
    fillGridFill((Control)group);
    GridLayout gridLayout = new GridLayout(10, false);
    gridLayout.horizontalSpacing = 12;
    gridLayout.marginTop = 0;
    gridLayout.marginHeight = 0;
    gridLayout.marginWidth = 0;
    comLayout.setLayout((Layout)gridLayout);
    this.bandwidthLabel = new Label(comLayout, 0);
    this.bandwidthLabel.setText(Messages.TerrestrialBandwidth + ":");
    fillHorizontal((Control)this.bandwidthLabel);
    this.bandwidthCombo = new Combo(comLayout, 8);
    this.bandwidthCombo.setItems(new String[] { Messages.TerrestrialBandwidthValue000, Messages.TerrestrialBandwidthValue001, Messages.TerrestrialBandwidthValue010 });
    this.bandwidthCombo.select(1);
    fillHorizontal((Control)this.bandwidthCombo);
    this.centreFrequencyLabel = new Label(comLayout, 0);
    this.centreFrequencyLabel.setText(Messages.TerrestrialCentreFrequency + ":");
    fillHorizontal((Control)this.centreFrequencyLabel);
    this.centreFrequencyText = new Text(comLayout, 16779268);
    this.centreFrequencyText.setText("177500000");
    this.centreFrequencyText.setTextLimit(11);
    fillHorizontal((Control)this.centreFrequencyText);
    setVerifyLongText(this.centreFrequencyText, Messages.TerrestrialCentreFrequency, 10, 42949672950L);
    this.centerFrequencyValid = new Label(comLayout, 0);
    this.centerFrequencyValid.setText("(10 ~ 42,949,672,950Hz)");
    fillHorizontal((Control)this.centerFrequencyValid, 240);
    this.constellationLabel = new Label(comLayout, 0);
    this.constellationLabel.setText(Messages.TerrestrialConstellation + ":");
    fillHorizontal((Control)this.constellationLabel);
    this.constellationCombo = new Combo(comLayout, 8);
    this.constellationCombo.setItems(new String[] { Messages.TerrestrialConstellation000, Messages.TerrestrialConstellation001, Messages.TerrestrialConstellation010 });
    this.constellationCombo.select(2);
    fillHorizontal((Control)this.constellationCombo);
  }
  
  private void setEnabledInsertLinked(boolean bool) {
    if (this.insertEmptyPacketBtn.getSelection()) {
      this.transferModeLabel.setVisible(bool);
      this.transferModeCombo.setVisible(bool);
      this.upgradetypeLabel.setVisible(bool);
      this.upgradetypeCombo.setVisible(bool);
    } else {
      this.transferModeLabel.setVisible(bool);
      this.transferModeCombo.setVisible(bool);
      this.upgradetypeLabel.setVisible(bool);
      this.upgradetypeCombo.setVisible(bool);
      this.symbolRateLabel.setVisible(bool);
      this.symbolRateText.setVisible(bool);
      this.mbpsLabel.setVisible(bool);
    } 
    if (this.transferModeCombo.getSelectionIndex() == 0) {
      this.cableModulationLabel.setVisible(bool);
      this.cableModulationCombo.setVisible(bool);
      this.cableFrequencyLabel.setVisible(bool);
      this.cableFrequencyText.setVisible(bool);
      this.cableFrequencyGHz.setVisible(bool);
    } else if (this.transferModeCombo.getSelectionIndex() == 1) {
      this.centreFrequencyLabel.setVisible(bool);
      this.centreFrequencyText.setVisible(bool);
      this.centerFrequencyValid.setVisible(bool);
      this.bandwidthLabel.setVisible(bool);
      this.bandwidthCombo.setVisible(bool);
      this.constellationLabel.setVisible(bool);
      this.constellationCombo.setVisible(bool);
    } 
  }
  
  private void setTransferModeSelect(int index, boolean select) {
    if (index == 0) {
      this.cableModulationLabel.setVisible(select);
      this.cableModulationCombo.setVisible(select);
      this.cableFrequencyLabel.setVisible(select);
      this.cableFrequencyText.setVisible(select);
      this.cableFrequencyGHz.setVisible(select);
      this.centreFrequencyLabel.setVisible(false);
      this.centreFrequencyText.setVisible(false);
      this.centerFrequencyValid.setVisible(false);
      this.bandwidthLabel.setVisible(false);
      this.bandwidthCombo.setVisible(false);
      this.constellationLabel.setVisible(false);
      this.constellationCombo.setVisible(false);
    } else if (index == 1) {
      this.centreFrequencyLabel.setVisible(select);
      this.centreFrequencyText.setVisible(select);
      this.centerFrequencyValid.setVisible(select);
      this.bandwidthLabel.setVisible(select);
      this.bandwidthCombo.setVisible(select);
      this.constellationLabel.setVisible(select);
      this.constellationCombo.setVisible(select);
      this.cableModulationLabel.setVisible(false);
      this.cableModulationCombo.setVisible(false);
      this.cableFrequencyLabel.setVisible(false);
      this.cableFrequencyText.setVisible(false);
      this.cableFrequencyGHz.setVisible(false);
    } 
  }
  
  private void setEnabledInsertEmpty(boolean bool) {
    if (this.insertLinkedDescriptorBtn.getSelection()) {
      this.validSymbolRateLabel.setVisible(bool);
      this.validSymbolRateText.setVisible(bool);
      this.mbpsLabel1.setVisible(bool);
    } else {
      this.symbolRateLabel.setVisible(bool);
      this.symbolRateText.setVisible(bool);
      this.mbpsLabel.setVisible(bool);
      this.validSymbolRateLabel.setVisible(bool);
      this.validSymbolRateText.setVisible(bool);
      this.mbpsLabel1.setVisible(bool);
    } 
  }
  
  private void setEnabledAll(boolean bool) {
    this.transferModeLabel.setVisible(bool);
    this.transferModeCombo.setVisible(bool);
    this.upgradetypeLabel.setVisible(bool);
    this.upgradetypeCombo.setVisible(bool);
    this.symbolRateLabel.setVisible(bool);
    this.symbolRateText.setVisible(bool);
    this.validSymbolRateLabel.setVisible(bool);
    this.validSymbolRateText.setVisible(bool);
    this.mbpsLabel.setVisible(bool);
    this.mbpsLabel1.setVisible(bool);
    this.cableModulationLabel.setVisible(bool);
    this.cableModulationCombo.setVisible(bool);
    this.cableFrequencyLabel.setVisible(bool);
    this.cableFrequencyText.setVisible(bool);
    this.cableFrequencyGHz.setVisible(bool);
    this.centreFrequencyLabel.setVisible(bool);
    this.centreFrequencyText.setVisible(bool);
    this.centerFrequencyValid.setVisible(bool);
    this.bandwidthLabel.setVisible(bool);
    this.bandwidthCombo.setVisible(bool);
    this.constellationLabel.setVisible(bool);
    this.constellationCombo.setVisible(bool);
  }
  
  public SsuPackageOptions getInput() {
    if (this.input == null)
      this.input = new SsuPackageOptions(); 
    this.input.setInsertLinkedDescriptorBtn(getInsertLinkedDescriptorBtn());
    this.input.setInsertEmptyPacket(getInsertEmptyPacket());
    this.input.setTransferModeCombo(getTransferModeCombo());
    this.input.setSymbolRate(getSymbolRateText());
    this.input.setValidSymbolRate(getValidSymbolRateText());
    this.input.setUpgradeTypeCombo(getUpgradetypeCombo());
    if (getTransferModeCombo() == 0) {
      this.input.setCableModulation(getCableModulationCombo());
      this.input.setCableFrequency(getCableFrequencyText());
    } else if (getTransferModeCombo() == 1) {
      Long frequency = getCentreFrequencyText();
      if (frequency == null)
        return null; 
      this.input.setCentreFrequency(frequency.longValue());
      this.input.setConstellation(getConstellationCombo());
      this.input.setBandWidth(getBandwidthCombo());
    } 
    return this.input;
  }
  
  public boolean getInsertLinkedDescriptorBtn() {
    return this.insertLinkedDescriptorBtn.getSelection();
  }
  
  public boolean getInsertEmptyPacket() {
    return this.insertEmptyPacketBtn.getSelection();
  }
  
  public int getUpgradetypeCombo() {
    return this.upgradetypeCombo.getSelectionIndex();
  }
  
  public int getTransferModeCombo() {
    return this.transferModeCombo.getSelectionIndex();
  }
  
  private Long getCentreFrequencyText() {
    try {
      return Long.valueOf(Long.valueOf(this.centreFrequencyText.getText()).longValue() / 10L);
    } catch (Exception exception) {
      return null;
    } 
  }
  
  public int getBandwidthCombo() {
    return this.bandwidthCombo.getSelectionIndex();
  }
  
  public int getConstellationCombo() {
    return this.constellationCombo.getSelectionIndex();
  }
  
  public int getSymbolRateText() {
    try {
      return Integer.parseInt(this.symbolRateText.getText());
    } catch (Exception exception) {
      return 0;
    } 
  }
  
  public int getValidSymbolRateText() {
    try {
      return Integer.parseInt(this.validSymbolRateText.getText());
    } catch (Exception exception) {
      return 0;
    } 
  }
  
  private void setVerifyIntText(Text fileSize, String title, int min, long max, int integerBits, int fractionalBits) {
    if (title == null)
      return; 
    fileSize.addFocusListener((FocusListener)new Object(this, fileSize, title, min, max, fractionalBits));
  }
  
  private void setVerifyLongText(Text fileSize, String title, int min, long max) {
    if (title == null)
      return; 
    fileSize.addFocusListener((FocusListener)new Object(this, fileSize, title, min, max));
  }
  
  public int getCableModulationCombo() {
    return this.cableModulationCombo.getSelectionIndex();
  }
  
  public double getCableFrequencyText() {
    try {
      return Double.parseDouble(this.cableFrequencyText.getText());
    } catch (Exception exception) {
      return 0.0D;
    } 
  }
  
  public static GridData fillGridFill(Control control) {
    GridData layoutData = new GridData(4, 1, true, false);
    control.setLayoutData(layoutData);
    return layoutData;
  }
}
